import { EventArgs, IList$1, Base, Type, IEnumerable$1, Point } from "igniteui-react-core";
import { IBucketizer } from "./IBucketizer";
import { IFastItemColumn$1 } from "igniteui-react-core";
import { Series } from "./Series";
import { Rect } from "igniteui-react-core";
import { ScalerParams } from "./ScalerParams";
import { SeriesView } from "./SeriesView";
import { Axis } from "./Axis";
import { IHasCategoryAxis } from "./IHasCategoryAxis";
import { IHasCategoryModePreference } from "./IHasCategoryModePreference";
import { Brush } from "igniteui-react-core";
import { CategoryAxisBase } from "./CategoryAxisBase";
import { NumericYAxis } from "./NumericYAxis";
import { HighlightingInfo } from "./HighlightingInfo";
import { CategoryTransitionInMode } from "./CategoryTransitionInMode";
import { CategoryTransitionSourceFramePreparer } from "./CategoryTransitionSourceFramePreparer";
import { CategoryFrame } from "./CategoryFrame";
import { CategoryMode } from "./CategoryMode";
import { List$1 } from "igniteui-react-core";
import { Dictionary$2 } from "igniteui-react-core";
import { CategorySeriesRenderManager } from "./CategorySeriesRenderManager";
import { AssigningCategoryStyleEventArgs } from "./AssigningCategoryStyleEventArgs";
import { TransitionInSpeedType } from "./TransitionInSpeedType";
import { FastItemsSourceEventAction } from "igniteui-react-core";
import { CalculatedColumn } from "./CalculatedColumn";
import { ColumnSupportingCalculation } from "./ColumnSupportingCalculation";
import { RenderSurface } from "./RenderSurface";
import { SupportingCalculation$1 } from "./SupportingCalculation$1";
/**
 * @hidden
 */
export declare class FinancialEventArgs extends EventArgs {
    static $t: Type;
    constructor(a: number, b: number, c: FinancialCalculationDataSource, d: FinancialCalculationSupportingCalculations, e: FinancialSeries);
    private _position;
    position: number;
    private _count;
    count: number;
    private _dataSource;
    dataSource: FinancialCalculationDataSource;
    private _supportingCalculations;
    supportingCalculations: FinancialCalculationSupportingCalculations;
    private _basedOn;
    basedOn: IList$1<string>;
}
/**
 * @hidden
 */
export declare class FinancialBucketCalculator extends Base implements IBucketizer {
    static $t: Type;
    protected a: FinancialSeriesView;
    constructor(a: FinancialSeriesView);
    getBucket(a: number): number[];
    getBucketWithoutUnknowns(a: number): number[];
    getErrorBucket(a: number, b: IFastItemColumn$1<number>): number;
    c: number;
    d: number;
    b: number;
    getBucketInfo(a: number, b: number, c: number, d: number): {
        p0: number;
        p1: number;
        p2: number;
        p3: number;
    };
    e(a: number): void;
    cacheValues(): void;
    unCacheValues(): void;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeries extends Series implements IHasCategoryAxis, IHasCategoryModePreference {
    static $t: Type;
    i2(a: SeriesView): void;
    my: FinancialSeriesView;
    protected get_cr(): boolean;
    ag(): Axis[];
    fs(a: any, b: string): any;
    protected oi(): number;
    private og;
    ah(a: Point): Point[][];
    ai(a: Point): Point[][];
    constructor();
    po: Brush;
    lj(): Brush;
    h1(): void;
    mi: CategoryAxisBase;
    m3: NumericYAxis;
    oy: string;
    nd: IFastItemColumn$1<number>;
    private m8;
    op: string;
    nb: IFastItemColumn$1<number>;
    private m6;
    ou: string;
    nc: IFastItemColumn$1<number>;
    private m7;
    om: string;
    na: IFastItemColumn$1<number>;
    private m5;
    o2: string;
    nf: IFastItemColumn$1<number>;
    private m9;
    no: boolean;
    protected ni: boolean;
    assigningCategoryStyle: (sender: any, args: AssigningCategoryStyleEventArgs) => void;
    protected nq(): boolean;
    protected pa(a: AssigningCategoryStyleEventArgs): void;
    protected mq: CategorySeriesRenderManager;
    protected o8(a: List$1<number[]>, b: number, c: number, d: CategoryAxisBase, e: ScalerParams, f: boolean): void;
    n8(a: Point): number;
    fe(a: Point, b: boolean): number;
    fc(a: Point, b: boolean): number;
    d9(a: Point, b: number, c: Axis, d: ScalerParams, e: number): number;
    getOffsetValue(): number;
    getCategoryWidth(): number;
    lv(a: Point, b: boolean, c: boolean): Point;
    en(a: Point, b: boolean, c: boolean): number;
    ej(a: Point, b: boolean, c: boolean): number;
    el(a: Point, b: boolean, c: boolean): number;
    oa(a: Point, b: boolean, c: boolean): number;
    ob(a: Point, b: boolean, c: boolean): number;
    oc(a: Point, b: boolean, c: boolean): number;
    lr(a: Point, b: boolean, c: boolean): Point;
    lt(a: Point, b: boolean, c: boolean): Point;
    pq(a: Point, b: boolean, c: boolean): Point;
    pp(a: Point, b: boolean, c: boolean): Point;
    pr(a: Point, b: boolean, c: boolean): Point;
    ik(): void;
    protected j1(a: Rect, b: Rect): void;
    protected j0(a: Rect, b: Rect): void;
    protected nt: Dictionary$2<IFastItemColumn$1<number>, string>;
    protected nu: Dictionary$2<string, string>;
    private ne;
    private o7;
    private nh;
    protected i7(a: any, b: string, c: any, d: any): void;
    nk(a: any): boolean;
    nj(a: any): boolean;
    protected mb(a: number, b: number, c: Axis): any[];
    protected of(a: SeriesView): number;
    protected oh(a: SeriesView): number;
    ma(a: number, b: number): any[];
    private m1;
    protected get_nm(): boolean;
    protected readonly nm: boolean;
    protected get_cv(): boolean;
    at(a: any, b: Point): HighlightingInfo;
    oj(a: Point): number;
    protected m0(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected mz(a: any, b: Point, c: HighlightingInfo): HighlightingInfo;
    protected nl(): boolean;
    eb(a: Point): number;
    e8(a: Point): number;
    protected get_c1(): boolean;
    ap(): CategoryAxisBase;
    fa(a: Point): number;
    fp(a: Point): any;
    ml: CategoryFrame;
    mn: CategoryFrame;
    mk: CategoryFrame;
    protected n9(a: Rect, b: Rect, c: Rect): number;
    ms: CategoryTransitionInMode;
    np: boolean;
    protected dc(): boolean;
    protected mr(): CategoryTransitionInMode;
    protected bo(): TransitionInSpeedType;
    pb(a: CategoryFrame, b: FinancialSeriesView): void;
    o9(a: CategoryFrame, b: FinancialSeriesView): void;
    dw(a: Rect, b: Rect, c: SeriesView): boolean;
    getViewInfo(a: Rect, b: Rect): {
        p0: Rect;
        p1: Rect;
    };
    mt: CategoryTransitionSourceFramePreparer;
    od(a: FinancialSeriesView): number;
    protected h4(): void;
    jm(a: boolean): void;
    typical: (sender: any, e: FinancialEventArgs) => void;
    typicalBasedOn: (sender: any, e: FinancialEventArgs) => void;
    protected nr(a: IList$1<string>): boolean;
    readonly ns: boolean;
    protected nn(): boolean;
    protected o6(a: FinancialEventArgs): void;
    protected readonly n0: IEnumerable$1<number>;
    private _nx;
    private nx;
    protected readonly nz: IEnumerable$1<number>;
    private _nw;
    private nw;
    protected readonly ny: IEnumerable$1<number>;
    private _nv;
    private nv;
    n2(a: IList$1<number>): IList$1<number>;
    private ng;
    protected n1(): IList$1<string>;
    private n6;
    getOpenColumnAsArray(): number[];
    private n4;
    getHighColumnAsArray(): number[];
    private n5;
    getLowColumnAsArray(): number[];
    private n3;
    getCloseColumnAsArray(): number[];
    private n7;
    getVolumeColumnAsArray(): number[];
    protected h6(a: FastItemsSourceEventAction, b: number, c: number, d: string): void;
    protected mu(a: number, b: number): FinancialCalculationDataSource;
    oe(a: number): number;
    protected mv(a: FinancialCalculationDataSource): FinancialCalculationSupportingCalculations;
    readonly categoryAxis: CategoryAxisBase;
    private mm;
    jn(a: Rect, b: RenderSurface): void;
    private mj;
    jk(a: Rect, b: Rect, c: RenderSurface, d: string, e: number): void;
    am(a: Axis): Axis;
    preferredCategoryMode(a: CategoryAxisBase): CategoryMode;
    private mo;
    mp: CategoryMode;
    protected get_cz(): boolean;
    jq(a: Brush, b: Brush): void;
    private pc;
    private m2;
    private m4;
    fr(a: any): any;
    static $$p: string[];
}
/**
 * @hidden
 */
export declare class FinancialCalculationSupportingCalculations extends Base {
    static $t: Type;
    a: ColumnSupportingCalculation;
    c: ColumnSupportingCalculation;
    d: ColumnSupportingCalculation;
    b: ColumnSupportingCalculation;
    h: DataSourceSupportingCalculation;
    f: DataSourceSupportingCalculation;
    g: DataSourceSupportingCalculation;
    e: DataSourceSupportingCalculation;
    k: (arg1: (arg1: number) => number, arg2: number, arg3: number) => IEnumerable$1<number>;
    j: (arg1: (arg1: number) => number, arg2: number) => IEnumerable$1<number>;
    i: (arg1: number) => number;
}
/**
 * @hidden
 */
export declare class DataSourceSupportingCalculation extends SupportingCalculation$1<(dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>> {
    static $t: Type;
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>);
    constructor(a: number, b: (dataSource: FinancialCalculationDataSource) => IEnumerable$1<number>, c: IList$1<string>);
    constructor(a: number, ..._rest: any[]);
}
/**
 * @hidden
 */
export declare class FinancialCalculationDataSource extends Base {
    static $t: Type;
    private _openColumn;
    openColumn: IList$1<number>;
    private _closeColumn;
    closeColumn: IList$1<number>;
    private _highColumn;
    highColumn: IList$1<number>;
    private _lowColumn;
    lowColumn: IList$1<number>;
    private _volumeColumn;
    volumeColumn: IList$1<number>;
    private _indicatorColumn;
    indicatorColumn: IList$1<number>;
    private _typicalColumn;
    typicalColumn: CalculatedColumn;
    private _trueRange;
    trueRange: CalculatedColumn;
    private _trueLow;
    trueLow: CalculatedColumn;
    private _period;
    period: number;
    private _shortPeriod;
    shortPeriod: number;
    private _longPeriod;
    longPeriod: number;
    private _count;
    count: number;
    private _calculateFrom;
    calculateFrom: number;
    private _calculateCount;
    calculateCount: number;
    private _multiplier;
    multiplier: number;
    private _minimumValue;
    minimumValue: number;
    private _maximumValue;
    maximumValue: number;
    private _specifiesRange;
    specifiesRange: boolean;
    private _series;
    series: FinancialSeries;
}
/**
 * @hidden
 */
export declare abstract class FinancialSeriesView extends SeriesView {
    static $t: Type;
    bw: FinancialSeries;
    bu: FinancialBucketCalculator;
    by: number;
    bx(a: CategoryFrame): boolean;
    bz(a: CategoryFrame): void;
    constructor(a: FinancialSeries);
    protected abstract bv(): FinancialBucketCalculator;
    ap(): void;
    getDefaultTooltipTemplate(): string;
    protected ac(): void;
}
